var Plugin = require('./plugin');

 /**
  * A function to get the instance data from the EC2 metadata service.
  * @param {function} callback - The callback for the plugin loader.
  */

var EC2Plugin = function (callback) {
  var METADATA_OPTIONS = {
    host: '169.254.169.254',
    path: '/latest/dynamic/instance-identity/document'
  };

  Plugin.getPluginMetadata(METADATA_OPTIONS, function (data) {
    var metadata;

    if (data)
      metadata = { ec2: { instance_id: data.instanceId, availability_zone: data.availabilityZone }};

    callback(metadata);
  });
};

module.exports = EC2Plugin;
